//________________________________________________________
//  main.c
//  ptcat
//
//  Created by Stanko Juzbasic on 1/3/13.
//  Copyleft (c) 2014. All rights reserved.
//
//________________________________________________________
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <math.h>

#define BOLDRED     "\033[1m\033[31m"      /* Bold Red */
#define RESET       "\033[0m"

#define dbp false
//________________________________________________________
//________________________________________________________
int     name_str_len(const char*);
void    usage(void);
//________________________________________________________
//________________________________________________________
int name_str_len(const char *s)
{
    int len;
    const char *ptr = s;
    for (len = 0; *ptr; ptr++, len++)
        // nothing
        ;
    return len;
}
//________________________________________________________
//________________________________________________________
void usage(void)
{
    //printf("\n"BOLDRED"USAGE:"RESET"\n\n");
    printf("\nUSAGE:\n\n");
    printf("ptcat <file_1> <file_2>... ...<file_n>\n\n");
    return;       
}
//________________________________________________________
//________________________________________________________
int main (int argc, const char * argv[])
{
    int numfiles;
    int i, j, k, m, n, p;
    int l, last;
    float o, t, max;
    char** filenames;
    FILE **afPtrs;
    bool *exists, first;
    int* firstnum;
    float* offset;
    char text[100];
    
    
    
//__verify_fail-safe_and_fool-proof_and_prepare_the_work__  
    numfiles = argc - 1; 
    
    if(dbp)printf("Number of files: %d\n", numfiles);
    
    if (numfiles == 0 ){
        usage();
        exit(-1);
    }
    
    filenames = (char**)malloc(numfiles*sizeof(char*));
    firstnum  = calloc(numfiles, sizeof(int));
    offset    = calloc(numfiles, sizeof(float));
    afPtrs    = (FILE**)malloc(numfiles*sizeof(FILE*));
    exists    = calloc(numfiles, sizeof(bool));
    
    for (i = 1; i < argc; i++){
        l = name_str_len(argv[i]); 
        filenames[i - 1] = (char*)malloc((l+1)*sizeof(char));
        strcpy(filenames[i - 1], argv[i]);
        if(dbp)printf("File: %s\n", filenames[i - 1]);        
    }
    
    for (i = 0; i < numfiles; i++){
        if((afPtrs[i] = fopen(filenames[i], "r")) == NULL){
            fprintf(stderr,"File \"%s\" not found\n", filenames[i]);
        }else {
            exists[i] = true;  
            if(dbp)printf("File: %s\tpointer: %p\n", filenames[i], afPtrs[i]);
        }
    }
    
    
//__do the work___________________________________________
    
    //initialize 'accumulators'
    n = 0; m = 0; o = 0.;                
    for (i = 0; i < numfiles; i++)
        offset[i] = 0.; 
    
    //get the numbers of partials and offsets
    for (i = 0; i < numfiles; i++){
        if(exists[i] == true){
            firstnum[i] = m; 
            offset[i] = o;
            max = 0;
            fscanf(afPtrs[i],"%s", text); // discard "("
            if(dbp)printf("%s ", text);
            if (strcmp(text,"(") != 0){
                fprintf(stderr, "%s: wrong file format\n", argv[0]);
                goto bail_out;
                }
            fscanf(afPtrs[i],"%s", text); // discard "PARTIALS"
            if (strcmp(text,"PARTIALS") != 0){
                fprintf(stderr, "%s: wrong file format\n", argv[0]);
                goto bail_out; 
                }
            if(dbp)printf("%s\t", text);
            fscanf(afPtrs[i],"%d", &n);
            if(dbp)printf("%d\n", n);
            
            for(j = 0; j < n; j++){
                fscanf(afPtrs[i],"%s",text);  // discard "("
                if(dbp)printf("%s ", text);
                fscanf(afPtrs[i],"%s",text);  // discard "POINTS"
                if(dbp)printf("%s\t", text);
                fscanf(afPtrs[i],"%d",&p);    // get num. points
                if(dbp)printf("%d\n", p);
                
                for (k = 0; k < p; k++){      // scroll through points
                    fscanf(afPtrs[i],"%f",&t);// get time 
                    if (t > max) max = t;     // find the end time
                    if(dbp)printf("    %f\t", t);
                    fscanf(afPtrs[i],"%s",text);//discard freq.
                    if(dbp)printf("%s\t", text);
                    fscanf(afPtrs[i],"%s",text);//discard amp.
                    if(dbp)printf("%s\n", text);
                }
                fscanf(afPtrs[i],"%s",text);    // discard ")"
                if(dbp)printf("%s\n", text);
            }
            fscanf(afPtrs[i],"%s",text);        // discard ")"
            if(dbp)printf("%s\n", text);
            m = m+n;                            // accumulate number of partials
            o = o+max+0.1;                      // accumulate offset times
        };
    }

    
    for (i = 0; i < numfiles; i++)
        if(exists[i] == true){
            if(dbp)printf("File: %s\tfirst partial#: %d\ttime_offset: %f\n", filenames[i], firstnum[i], offset[i]);
            last = i;
        }
   
//__now read again with correct assignments, append data,
//  discard what is to be discarded
//  change what is to be changed
//  print everything to stdout
    
    if(dbp)printf("\n//////////////////////////////////////////////////\n\n");
    
    //rewind file pointers
    for (i = 0; i < numfiles; i++)
        if(exists[i] == true) 
            rewind(afPtrs[i]);
    
    //make sure we hit the first existing file
    first = true;
    
    //append partials
    for (i = 0; i < numfiles; i++){
        if(exists[i] == true){
    //        firstnum[i] = m; 
    //        offset[i] = o;
    //         max = 0;
            fscanf(afPtrs[i],"%s" , text); // get "("
            if(first) printf("%s ", text);

            fscanf(afPtrs[i],"%s", text);  // get "PARTIALS"
 
            if(first) printf("%s\t", text);
            fscanf(afPtrs[i],"%d", &n);    // get num. partials
            if(first) printf("%d\n", m);   // replace it with the accumulated number
            
            for(j = 0; j < n; j++){
                fscanf(afPtrs[i],"%s",text);  // recycle "("
                printf("%s ", text);
                fscanf(afPtrs[i],"%s",text);  // recycle "POINTS"
                printf("%s\t", text);
                fscanf(afPtrs[i],"%d",&p);   // get num. points, for the "k"-loop
                printf("%d\n", p);
                
                for (k = 0; k < p; k++){      // scroll through points
                    fscanf(afPtrs[i],"%f",&t);// get time, modify and return it 
                    t = t + offset[i];
                    printf("    %f\t", t );
                    fscanf(afPtrs[i],"%s",text);//recycle freq.
                    printf("%s\t", text);
                    fscanf(afPtrs[i],"%s",text);//recycle amp.
                    printf("%s\n", text);
                }
                fscanf(afPtrs[i],"%s",text);    // recycle ")"
                printf("%s\n", text);
            }
            fscanf(afPtrs[i],"%s",text);        // get ")"
        first = false;   
        };
        
    }
    printf(")\n");
    
    
        
//__do the cleanup________________________________________   
    bail_out:
    for (i = numfiles - 1; i > 0; i--){
        if(exists[i] == true)
            fclose(afPtrs[i]);
    }
    
    for (i = numfiles - 1; i > 0; i--)
        free(filenames[i]);
    
    free(exists);
    free(afPtrs);
    free(offset);
    free(firstnum);
    free(filenames);
    return 0;
}

